package com.dj.action.sys;

import org.apache.log4j.Logger;
import org.apache.struts2.convention.annotation.Action;
import org.apache.struts2.convention.annotation.Result;
import org.springframework.beans.factory.annotation.Autowired;
import com.dj.action.base.BaseAction;
import com.dj.pageModel.base.Json;
import com.dj.pageModel.sys.Gas;
import com.dj.pageModel.sys.Worktimeout;
import com.dj.service.sys.GasServiceI;
import com.dj.service.sys.WorktimeoutServiceI;
import com.dj.util.base.ExceptionUtil;
import com.opensymphony.xwork2.ModelDriven;

/**
 * 超时记录
 * 
 * @author lili
 * 
 */
@Action(value = "worktimeout", results = {
		@Result(name = "worktimeout", location = "/general/admin/worktimeout.jsp"),
		@Result(name = "worktimeoutHistory", location = "/general/admin/worktimeoutHistory.jsp") })
public class WorktimeoutAction extends BaseAction implements
		ModelDriven<Worktimeout> {

	private static final long serialVersionUID = 1L;

	private static final Logger logger = Logger
			.getLogger(WorktimeoutAction.class);

	private WorktimeoutServiceI worktimeoutService;

	public WorktimeoutServiceI getWorktimeoutService() {
		return worktimeoutService;
	}

	@Autowired
	public void setWorktimeoutService(WorktimeoutServiceI worktimeoutService) {
		this.worktimeoutService = worktimeoutService;
	}

	private Worktimeout worktimeout = new Worktimeout();

	public Worktimeout getModel() {
		return worktimeout;
	}

	public String worktimeout() {
		return "worktimeout";
	}
	public String worktimeoutHistory()
	{
		return "worktimeoutHistory";
	}

	/**
	 * 获得bug数据表格
	 */
	public void datagrid() {
		super.writeJson(worktimeoutService.datagrid(worktimeout));
	}

	public void addtime() {
		Json j = new Json();
		try {
			worktimeoutService.addtime(worktimeout.getIds());
			j.setSuccess(true);
			j.setMsg("处理成功！");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("处理失败！");
		}
		super.writeJson(j);
	}

	public void miss() {
		Json j = new Json();
		try {
			worktimeoutService.miss(worktimeout.getIds());
			j.setSuccess(true);
			j.setMsg("处理成功！");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("处理失败！");
		}
		super.writeJson(j);
	}

	public void ignore() {
		Json j = new Json();
		try {
			worktimeoutService.ignore(worktimeout.getIds());
			j.setSuccess(true);
			j.setMsg("处理成功！");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("处理失败！");
		}
		super.writeJson(j);
	}

}
