package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.List;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import com.dj.dao.base.BaseDaoI;
import com.dj.model.sys.Tgas;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Gas;
import com.dj.service.base.impl.BaseServiceImpl;
import com.dj.service.sys.GasServiceI;



@Service("gasService")
public class GasServiceImpl extends BaseServiceImpl implements GasServiceI {

	private BaseDaoI<Tgas> gasDao;

	public BaseDaoI<Tgas> getGasDao() {
		return gasDao;
	}

	@Autowired
	public void setGasDao(BaseDaoI<Tgas> gasDao) {
		this.gasDao = gasDao;
	}

	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Gas gas) {
		DataGrid j = new DataGrid();
		j.setRows(changeModel(find(gas)));
		j.setTotal(total(gas));
		return j;
	}

	private List<Gas> changeModel(List<Tgas> tgass) {
		List<Gas> gass = new ArrayList<Gas>();
		if (tgass != null && tgass.size() > 0) {
			for (Tgas tb : tgass) {
				Gas b = new Gas();
				BeanUtils.copyProperties(tb, b);
				gass.add(b);
			}
		}
		return gass;
	}


	private List<Tgas> find(Gas gas) {
		String hql = "from Tgas t where 1=1 ";

		List<Object> values = new ArrayList<Object>();
		hql = addWhere(gas, hql, values);

		if (gas.getSort() != null && gas.getOrder() != null) {
			hql += " order by " + gas.getSort() + " " + gas.getOrder();
		}
		return gasDao.find(hql, values, gas.getPage(), gas.getRows());
	}

	private Long total(Gas gas) {
		String hql = "select count(*) from Tgas t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = addWhere(gas, hql, values);
		return gasDao.count(hql, values);
	}

	private String addWhere(Gas gas, String hql, List<Object> values) {
		
		if(gas.getSensorname() !=null && !"".equals(gas.getSensorname().trim()))
		{
			hql += " and t.sensorname like ? ";
			values.add("%%" + gas.getSensorname().trim() + "%%");
			
		}
		if (gas.getJctimeStart()  != null) {
			hql += " and t.jctime>=? ";
			values.add(gas.getJctimeStart());
		}
		if (gas.getJctimeEnd()  != null) {
			hql += " and t.jctime<=? ";
			values.add(gas.getJctimeEnd());
		}
		
		return hql;
	}



}
