package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.List;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import com.dj.dao.base.BaseDaoI;
import com.dj.model.sys.Twind;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Wind;
import com.dj.service.base.impl.BaseServiceImpl;
import com.dj.service.sys.WindServiceI;


@Service("windService")
public class WindServiceImpl extends BaseServiceImpl implements WindServiceI {

	private BaseDaoI<Twind> windDao;

	public BaseDaoI<Twind> getWindDao() {
		return windDao;
	}

	@Autowired
	public void setWindDao(BaseDaoI<Twind> windDao) {
		this.windDao = windDao;
	}

	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Wind wind) {
		DataGrid j = new DataGrid();
		j.setRows(changeModel(find(wind)));
		j.setTotal(total(wind));
		return j;
	}

	private List<Wind> changeModel(List<Twind> twinds) {
		List<Wind> winds = new ArrayList<Wind>();
		if (twinds != null && twinds.size() > 0) {
			for (Twind tb : twinds) {
				Wind b = new Wind();
				BeanUtils.copyProperties(tb, b);
				winds.add(b);
			}
		}
		return winds;
	}

	private List<Twind> find(Wind wind) {
		String hql = "from Twind t where 1=1 ";

		List<Object> values = new ArrayList<Object>();
		hql = addWhere(wind, hql, values);

		if (wind.getSort() != null && wind.getOrder() != null) {
			hql += " order by " + wind.getSort() + " " + wind.getOrder();
		}
		return windDao.find(hql, values, wind.getPage(), wind.getRows());
	}

	private Long total(Wind wind) {
		String hql = "select count(*) from Twind t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = addWhere(wind, hql, values);
		return windDao.count(hql, values);
	}

	private String addWhere(Wind wind, String hql, List<Object> values) {
		
		if(wind.getSensorname() !=null && !"".equals(wind.getSensorname().trim()))
		{
			hql += " and t.sensorname like ? ";
			values.add("%%" + wind.getSensorname().trim() + "%%");
			
		}
		if (wind.getJctimeStart()  != null) {
			hql += " and t.jctime>=? ";
			values.add(wind.getJctimeStart());
		}
		if (wind.getJctimeEnd()  != null) {
			hql += " and t.jctime<=? ";
			values.add(wind.getJctimeEnd());
		}
		
		return hql;
	}



}
